Index: /trunk/include/VBox/version.h
===================================================================
--- /trunk/include/VBox/version.h	(revision 26033)
+++ /trunk/include/VBox/version.h	(revision 26034)
@@ -73,4 +73,7 @@
 #define VBOX_VENDOR                     "Sun Microsystems, Inc."
 
+/** Product name */
+#define VBOX_PRODUCT                    "Sun VirtualBox"
+
 /** @name Prefined strings for Windows resource files
  *
Index: /trunk/src/VBox/Frontends/VBoxFB/VBoxFB.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxFB/VBoxFB.cpp	(revision 26033)
+++ /trunk/src/VBox/Frontends/VBoxFB/VBoxFB.cpp	(revision 26034)
@@ -66,5 +66,5 @@
 
     printf("VirtualBox DirectFB GUI built %s %s\n"
-           "(C) 2004-2009 Sun Microsystems, Inc.\n"
+           "(C) 2004-2010 " VBOX_VENDOR "\n"
            "(C) 2004-2005 secunet Security Networks AG\n", __DATE__, __TIME__);
 
Index: /trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp	(revision 26033)
+++ /trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp	(revision 26034)
@@ -623,8 +623,7 @@
 
     LogFlow (("VBoxHeadless STARTED.\n"));
-    RTPrintf ("VirtualBox Headless Interface %s\n"
-              "(C) 2008-2009 Sun Microsystems, Inc.\n"
-              "All rights reserved.\n\n",
-              VBOX_VERSION_STRING);
+    RTPrintf (VBOX_PRODUCT " Headless Interface " VBOX_VERSION_STRING "\n"
+              "(C) 2008-2010 " VBOX_VENDOR "\n"
+              "All rights reserved.\n\n");
 
     Bstr id;
Index: /trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp	(revision 26033)
+++ /trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp	(revision 26034)
@@ -41,7 +41,7 @@
     if (!s_fShown)
     {
-        RTPrintf("VirtualBox Command Line Management Interface Version "
+        RTPrintf(VBOX_PRODUCT" Command Line Management Interface Version "
                  VBOX_VERSION_STRING  "\n"
-                 "(C) 2005-2009 Sun Microsystems, Inc.\n"
+                 "(C) 2005-2010 " VBOX_VENDOR "\n"
                  "All rights reserved.\n"
                  "\n");
Index: /trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 26033)
+++ /trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 26034)
@@ -979,6 +979,6 @@
 
     LogFlow(("SDL GUI started\n"));
-    RTPrintf("Sun VirtualBox SDL GUI version %s\n"
-             "(C) 2005-2009 Sun Microsystems, Inc.\n"
+    RTPrintf(VBOX_PRODUCT " SDL GUI version %s\n"
+             "(C) 2005-2010 " VBOX_VENDOR "\n"
              "All rights reserved.\n\n",
              VBOX_VERSION_STRING);
@@ -4276,5 +4276,5 @@
 
 
-    strcpy(szTitle, "Sun VirtualBox - ");
+    strcpy(szTitle, VBOX_PRODUCT " - ");
 
     Bstr name;
@@ -4408,5 +4408,5 @@
     setUITitle(szTitle);
 #else
-    SDL_WM_SetCaption(szTitle, "Sun VirtualBox");
+    SDL_WM_SetCaption(szTitle, VBOX_PRODUCT);
 #endif
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxAboutDlg.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxAboutDlg.cpp	(revision 26033)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxAboutDlg.cpp	(revision 26034)
@@ -75,5 +75,5 @@
 #if VBOX_OSE
     mAboutText = aboutText + " " + versionText.arg (mVersion) + "\n" +
-                 QString ("%1 2004-2009 Sun Microsystems, Inc.").arg (QChar (0xa9));
+                 QString ("%1 2004-2010 " VBOX_VENDOR).arg (QChar (0xa9));
 #else /* VBOX_OSE */
     mAboutText = aboutText + "\n" +
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 26033)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 26034)
@@ -23,4 +23,5 @@
 #include "VBoxGlobal.h"
 #include <VBox/VBoxHDD.h>
+#include <VBox/version.h>
 
 #include "VBoxDefs.h"
@@ -2660,5 +2661,5 @@
 QString VBoxGlobal::languageTranslators() const
 {
-    return qApp->translate ("@@@", "Sun Microsystems, Inc.",
+    return qApp->translate ("@@@", VBOX_VENDOR,
                             "Comma-separated list of translators");
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/main.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/main.cpp	(revision 26033)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/main.cpp	(revision 26034)
@@ -62,4 +62,5 @@
 #include <iprt/stream.h>
 #include <VBox/err.h>
+#include <VBox/version.h>
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
 
@@ -258,6 +259,6 @@
 #endif
 
-    RTPrintf("Sun VirtualBox Graphical User Interface %s\n"
-            "(C) 2005-2009 Sun Microsystems, Inc.\n"
+    RTPrintf(VBOX_PRODUCT " Graphical User Interface %s\n"
+            "(C) 2005-2010 " VBOX_VENDOR "\n"
             "All rights reserved.\n"
             "\n"
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/VBoxGLSettingsLanguage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/VBoxGLSettingsLanguage.cpp	(revision 26033)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/VBoxGLSettingsLanguage.cpp	(revision 26034)
@@ -33,4 +33,5 @@
 #include <iprt/param.h>
 #include <iprt/path.h>
+#include <VBox/version.h>
 
 extern const char *gVBoxLangSubDir;
@@ -70,5 +71,5 @@
 
         QString translatorsName = tratra (aTranslator,
-            "@@@", "Sun Microsystems, Inc.", "Comma-separated list of translators");
+            "@@@", VBOX_VENDOR, "Comma-separated list of translators");
 
         QString itemName = nativeLanguage;
Index: /trunk/src/VBox/Main/generic/OpenGLTestApp.cpp
===================================================================
--- /trunk/src/VBox/Main/generic/OpenGLTestApp.cpp	(revision 26033)
+++ /trunk/src/VBox/Main/generic/OpenGLTestApp.cpp	(revision 26034)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2009 Sun Microsystems, Inc.
+ * Copyright (C) 2009-2010 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -286,6 +286,6 @@
 #endif
                 case 'h':
-                    RTPrintf("VirtualBox Helper for testing 2D/3D OpenGL capabilities %u.%u.%u\n"
-                             "(C) 2009 Sun Microsystems, Inc.\n"
+                    RTPrintf(VBOX_PRODUCT " Helper for testing 2D/3D OpenGL capabilities %u.%u.%u\n"
+                             "(C) 2009-2010 " VBOX_VENDOR "\n"
                              "All rights reserved.\n"
                              "\n"
Index: /trunk/src/VBox/Main/webservice/vboxweb.cpp
===================================================================
--- /trunk/src/VBox/Main/webservice/vboxweb.cpp	(revision 26033)
+++ /trunk/src/VBox/Main/webservice/vboxweb.cpp	(revision 26034)
@@ -6,5 +6,5 @@
  *      server, to which clients can connect.
  *
- * Copyright (C) 2006-2009 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2010 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -265,7 +265,7 @@
     RTR3Init();
 
-    RTStrmPrintf(g_pStdErr, "Sun VirtualBox Webservice Version %s\n"
-                            "(C) 2005-2009 Sun Microsystems, Inc.\n"
-                            "All rights reserved.\n", VBOX_VERSION_STRING);
+    RTStrmPrintf(g_pStdErr, VBOX_PRODUCT " Webservice Version " VBOX_VERSION_STRING "\n"
+                            "(C) 2005-2010 " VBOX_VENDOR "\n"
+                            "All rights reserved.\n");
 
     int c;
Index: /trunk/src/VBox/Main/xpcom/server.cpp
===================================================================
--- /trunk/src/VBox/Main/xpcom/server.cpp	(revision 26033)
+++ /trunk/src/VBox/Main/xpcom/server.cpp	(revision 26034)
@@ -1018,10 +1018,10 @@
 
             iSize = RTStrPrintf(szBuf, sizeof(szBuf),
-                                "Sun VirtualBox XPCOM Server Version "
+                                VBOX_PRODUCT" XPCOM Server Version "
                                 VBOX_VERSION_STRING);
             for (int i = iSize; i > 0; i--)
                 putchar('*');
             RTPrintf("\n%s\n", szBuf);
-            RTPrintf("(C) 2008-2009 Sun Microsystems, Inc.\n"
+            RTPrintf("(C) 2008-2010 " VBOX_VENDOR "\n"
                      "All rights reserved.\n");
 #ifdef DEBUG
Index: /trunk/src/VBox/RDP/client/rdesktop.c
===================================================================
--- /trunk/src/VBox/RDP/client/rdesktop.c	(revision 26033)
+++ /trunk/src/VBox/RDP/client/rdesktop.c	(revision 26034)
@@ -39,4 +39,8 @@
 #include <errno.h>
 #include "rdesktop.h"
+
+#ifdef VBOX
+# include <VBox/version.h>
+#endif
 
 #ifdef HAVE_LOCALE_H
@@ -147,5 +151,5 @@
 	fprintf(stderr, "rdesktop: A Remote Desktop Protocol client.\n");
 	fprintf(stderr, "Version " VERSION ". Copyright (C) 1999-2008 Matthew Chapman.\n");
-        fprintf(stderr, "Modified for VirtualBox by Sun Microsystems, Inc.\n");
+        fprintf(stderr, "Modified for VirtualBox by " VBOX_VENDOR "\n");
 	fprintf(stderr, "See http://www.rdesktop.org/ for more information.\n\n");
 